function K2BExtendedSuggest() {
  this.control = null;
  this.Values = null;
  this.data = null;

  this.SetAttribute = function (data) {
    if (this.control != null) {
      if (data !== null) this.control.value = [data];
      else this.control.value = [];
      this.updateDescription();
    }
    this.data = data;
  };

  this.GetAttribute = function () {
    return this.data;
  };

  this.SetValues = function (v) {
    this.Values = v;
    if (this.control != null) {
      this.control.values = this.Values;
      if (this.control.value != null && this.control.value.length !== 0) {
        this.updateDescription();
      }
    }
  };

  this.updateDescription = function () {
    (async () => {
      await customElements.whenDefined('k2bt-enhancedsuggest');
      const element = this.control;
      await element.updateDescription();
    })();
  };

  this.SetValue = function (v) {
    this.SetAttribute(v);

    this.onfocus();
    this.oninput();
    this.onchange();

    if (this.ControlValueChanged) {
      this.ControlValueChanged();
    }
  };

  this.show = function () {
    var uc = this;
    var container = document.getElementById(this.ContainerName);
    if (this.control == null) {
      // Only create control once
      this.control = document.createElement('k2bt-enhancedsuggest');
      this.control.clientSideFiltering = this.ClientSideFiltering;
      this.control.values = this.Values;
      this.control.value = [this.data];

      this.control.addEventListener('suggestValueChanged', function () {
        var value;
        if (uc.control.value != null && uc.control.value.length > 0) value = uc.control.value[0];
        else value = null;

        uc.SetAttribute(value);

        uc.oninput();
        uc.onchange();

        if (uc.ControlValueChanged) {
          uc.ControlValueChanged();
        }
      });

      this.control.addEventListener('newRecordClicked', function () {
        if (uc.CreateItem) {
          uc.CreateItem();
        }
      });

      this.control.addEventListener('inputValueChanged', function () {
        uc.Prefix = uc.control.searchvalue;
        if (uc.SeekSuggestValues) {
          uc.SeekSuggestValues();
        }
      });

      this.control.addEventListener('focus', this.onfocus.closure(this));
      container.appendChild(this.control);
    }
    this.control.enableadditem = this.EnableAddItem;
    this.control.includeemptyitem = this.IncludeEmptyItem;
    this.control.enabled = this.Enabled;
    this.control.readonlyclass = this.Class.split(' ')
      .map(s => 'Readonly' + s)
      .join(' ');

    this.control.emptyitemtext = k2btools.getTranslatedMessage(k2btools.resolveValue(this.EmptyItemText, 'GX_EmptyItemText'));
    this.control.noresultsfoundtext = k2btools.getTranslatedMessage(k2btools.resolveValue(this.NoResultsFoundText, 'K2BT_NoItems'));
    this.control.additemcaption = k2btools.getTranslatedMessage(k2btools.resolveValue(this.AddItemCaption, 'K2BT_EnhancedComboAddItemCaption'));
    this.control.suggestmaxitems = this.SuggestMaxItems;

    k2btools.updateFormControlVisibility(container, this.Visible);
  };
}
