function K2BSplitDatePicker() {
  this.control = null;
  this.data = null;

  // Databinding for property Attribute
  this.SetAttribute = function (data) {
    ///UserCodeRegionStart:[SetAttribute] (do not remove this comment.)
    var date = k2btools.parseAttributeDate(data);

    // Check that the format received is coherent
    if (k2btools.formatAttributeDate(date) === data || k2btools.formatAttributeDatetime(date) === data) {
      this.data = data;
      if (this.control != null) this.control.value = date;
    } else {
      console.log('Received incorrect date format: ' + data);
    }
    ///UserCodeRegionEnd: (do not remove this comment.)
  };

  // Databinding for property Attribute
  this.GetAttribute = function () {
    ///UserCodeRegionStart:[GetAttribute] (do not remove this comment.)
    //return k2btools.formatAttributeDate(this.data);
    return this.data;
    ///UserCodeRegionEnd: (do not remove this comment.)
  };

  this.show = function () {
    try {
      var uc = this;
      var container = document.getElementById(this.ContainerName);
      if (this.control == null) {
        // Only create control once
        this.control = document.createElement('k2bt-split-datepicker');

        var date = k2btools.parseAttributeDate(this.data);
        this.control.value = date;
        this.control.minimumdate = k2btools.parseDateTimeAsLocal(this.MinimumDate);
        this.control.maximumdate = k2btools.parseDateTimeAsLocal(this.MaximumDate);
        this.control.showmonthas = this.ShowMonthAs;
        this.control.fieldcontroltype = this.FieldControlType;
        this.control.dayinvitemessage = k2btools.getTranslatedMessage(this.DayInviteMessage);
        this.control.monthinvitemessage = k2btools.getTranslatedMessage(this.MonthInviteMessage);
        this.control.yearinvitemessage = k2btools.getTranslatedMessage(this.YearInviteMessage);
        this.control.hourinvitemessage = k2btools.getTranslatedMessage(this.HourInviteMessage);
        this.control.minuteinvitemessage = k2btools.getTranslatedMessage(this.MinuteInviteMessage);

        this.control.daynotfoundmessage = k2btools.getTranslatedMessage(this.DayNotFoundMessage);
        this.control.monthnotfoundmessage = k2btools.getTranslatedMessage(this.MonthNotFoundMessage);
        this.control.yearnotfoundmessage = k2btools.getTranslatedMessage(this.YearNotFoundMessage);
        this.control.hournotfoundmessage = k2btools.getTranslatedMessage(this.HourNotFoundMessage);
        this.control.minutenotfoundmessage = k2btools.getTranslatedMessage(this.MinuteNotFoundMessage);

        this.control.fieldorder = this.FieldOrder === '' || this.FieldOrder === 'Default' ? gx.dateFormat : this.FieldOrder;
        this.control.showtimepart = this.ShowTimePart;

        this.control.hourformat = this.HourFormat;
        this.control.starthour = this.StartHour;
        this.control.endhour = this.EndHour;
        this.control.minutestep = this.MinuteStep;

        this.control.displaydayofmonthascombo = this.DisplayDayOfMonthAsCombo;
        this.control.readonlyclass = this.Class.split(' ')
          .map(s => 'Readonly' + s)
          .join(' ');
        this.control.enabled = this.Enabled;

        this.control.addEventListener('dateinput', function () {
          uc.Error = uc.control.validationerrorcode;
          if (uc.control.value != null) {
            const date = uc.control.value;

            if (uc.ShowTimePart) uc.SetAttribute(k2btools.formatAttributeDatetime(date));
            else uc.SetAttribute(k2btools.formatAttributeDate(date));
          }

          if (uc.IsValid) uc.IsValid();
        });

        this.control.addEventListener('datechange', function () {
          uc.onfocus();
          uc.oninput();
          uc.onchange();
        });

        this.control.addEventListener('datechange', function () {
          if (uc.ControlValueChanged) {
            uc.ControlValueChanged();
          }
        });
        container.appendChild(this.control);
      }

      k2btools.updateFormControlVisibility(container, this.Visible);
    } catch (e) {
      console.log(e);
    }
  };
}
