function K2BWizardSteps(JQuery) {
  this.SelectedStep = 1;
  this.CurrentStep = 1;
  this._$ = JQuery;

  this.SetWizardSteps = function (data) {
    this.WizardSteps = data;
  };

  this.GetWizardSteps = function () {
    return this.WizardSteps;
  };

  this.SetSelectedStep = function (data) {
    this.SelectedStep = data;
  };

  this.GetSelectedStep = function () {
    return this.SelectedStep;
  };

  this.SetCurrentStep = function (data) {
    this.CurrentStep = parseInt(data);
  };

  this.GetCurrentStep = function () {
    return this.CurrentStep;
  };

  this.show = function () {
    try {
      var _wizard = this;
      var mainNode, ulNode;
      if (!this.IsPostBack) {
        mainNode = _wizard._$('<div>').addClass('K2BWizardSteps').attr('id', _wizard.ControlName);
        ulNode = _wizard._$('<ul>').attr('id', 'main' + _wizard.ControlName);
        mainNode.append(ulNode);
      } else {
        _wizard._$('#' + _wizard.DesignContainerName).off('click');
        mainNode = _wizard._$(_wizard._$.find('div#' + _wizard.ControlName));
        ulNode = _wizard._$(_wizard._$.find('ul#main' + _wizard.ControlName));
        ulNode.empty();
      }
      var nextStepAllowClick = false;
      var isWizardCompleted = _wizard.CurrentStep > _wizard.WizardSteps.length || _wizard.WizardCompleted === 'true' || _wizard.WizardCompleted;
      if (isWizardCompleted) {
        mainNode.addClass('WizardCompleted');
      }

      for (var i = 0; i < _wizard.WizardSteps.length; i++) {
        const step = _wizard.WizardSteps[i];
        var li;
        ({ li, nextStepAllowClick } = this.createLiElement(_wizard, i, isWizardCompleted, step, nextStepAllowClick));
        this.createStepContents(_wizard, li, isWizardCompleted, step);
        ulNode.append(li);
      }

      if (!this.IsPostBack) {
        this.setHtml(mainNode[0].outerHTML);
      }
    } catch (e) {
      console.log(e);
    }
  };

  this.createLiElement = function (_wizard, i, isWizardCompleted, step, nextStepAllowClick) {
    var li = _wizard._$('<li>');
    nextStepAllowClick = this.setLiElementClasses(_wizard, i, li, isWizardCompleted, step, nextStepAllowClick);

    mystep = i + 1;
    var liControlName = _wizard.ControlName + 'Step' + mystep;
    li.attr('id', liControlName);

    
    _wizard._$("#"+ _wizard.DesignContainerName).on("click", "li#" + liControlName + ".StepAllowClick", {currentStep:i+1}, function (e) {
      if (typeof(_wizard.WizardStepClicked) == 'function'){
        _wizard.SelectedStep = e.data.currentStep;
        _wizard.WizardStepClicked();
      }
    });

    return { li, nextStepAllowClick };
  };

  this.createStepContents = function (_wizard, li, isWizardCompleted, step) {
    var innerDiv = _wizard._$('<div>');
    li.append(innerDiv);

    var spanNumber = _wizard._$('<span>').addClass('WizardNumber');

    if (isWizardCompleted && mystep === _wizard.WizardSteps.length) {
      li.addClass('StepSelected');
    } else if (step.IconURL != null && step.IconURL !== '' && step.IconURL !== undefined) {
      var img = $('<img>');
      img.addClass('K2BT_WizardStepIcon');
      img.attr('src', step.IconURL);
      spanNumber.append(img);
    } else {
      spanNumber.text(step.StepNumber);
    }

    var spanTitle = _wizard._$('<span>').addClass('WizardTitle');

    spanTitle.text(step.StepName);
    innerDiv.append(spanNumber);
    innerDiv.append(spanTitle);
  };

  this.setLiElementClasses = function (_wizard, i, li, isWizardCompleted, step, nextStepAllowClick) {
    this.setStepAppearanceClasses(step, li);
    return this.setClassesBasedOnWizardStatus(_wizard, i, li, isWizardCompleted, step, nextStepAllowClick);
  };

  this.setStepAppearanceClasses = function (step, li) {
    if (step.IsMinor) li.addClass('K2BT_MinorStep');
    if (!step.Available) li.addClass('NotAvailableStep');
  };

  this.setClassesBasedOnWizardStatus = function (_wizard, i, li, isWizardCompleted, step, nextStepAllowClick) {
    if (_wizard.CurrentStep === i + 1) {
      li.addClass('StepSelected');
      if (isWizardCompleted) li.addClass('StepCompleted');
    } else if (_wizard.CurrentStep > i + 1) {
      li.addClass('StepCompleted');
      if (step.Available && !isWizardCompleted) li.addClass('StepAllowClick');
                                                             
    } else if ((_wizard.CurrentStep === i || nextStepAllowClick) && !isWizardCompleted) {
      //Next selectable element
      if (step.Available) {
        nextStepAllowClick = false;
        li.addClass('StepAllowClick');
      } else {
        nextStepAllowClick = true;
      }
    }
    return nextStepAllowClick;
  };
}
